#!/bin/bash

working_dir=/tmp/gostsum_from_deb_test_`date +%s`

function create_DEBIAN_dir()
{
    mkdir -p $working_dir/deb_source/DEBIAN/

    echo "package: test" > $working_dir/deb_source/DEBIAN/control
    echo "version: 0.0.1" >> $working_dir/deb_source/DEBIAN/control
    echo "architecture: amd64" >> $working_dir/deb_source/DEBIAN/control
    echo "maintainer: rusbitech <support@rusbitech.ru>" >> $working_dir/deb_source/DEBIAN/control
    echo "description: test" >> $working_dir/deb_source/DEBIAN/control
    echo "" >> $working_dir/deb_source/DEBIAN/control
}

function create_gostsum_test_files()
{
    echo -n "This is message, length=32 bytes" > $working_dir/deb_source/34.11.94_test_message_1
    echo -n "Suppose the original message has length = 50 bytes" > $working_dir/deb_source/34.11.94_test_message_2

    echo -en "\x30\x31\x32\x33\x34\x35\x36\x37\x38\x39\x30\x31\x32\x33\x34\x35\x36" > $working_dir/deb_source/34.11.2012_test_message_1
    echo -en "\x37\x38\x39\x30\x31\x32\x33\x34\x35\x36\x37\x38\x39\x30\x31\x32\x33" >> $working_dir/deb_source/34.11.2012_test_message_1
    echo -en "\x34\x35\x36\x37\x38\x39\x30\x31\x32\x33\x34\x35\x36\x37\x38\x39\x30" >> $working_dir/deb_source/34.11.2012_test_message_1
    echo -en "\x31\x32\x33\x34\x35\x36\x37\x38\x39\x30\x31\x32" >> $working_dir/deb_source/34.11.2012_test_message_1

    echo -en "\xd1\xe5\x20\xe2\xe5\xf2\xf0\xe8\x2c\x20\xd1\xf2\xf0\xe8\xe1\xee\xe6" > $working_dir/deb_source/34.11.2012_test_message_2
    echo -en "\xe8\x20\xe2\xed\xf3\xf6\xe8\x2c\x20\xe2\xe5\xfe\xf2\xfa\x20\xf1\x20" >> $working_dir/deb_source/34.11.2012_test_message_2
    echo -en "\xec\xee\xf0\xff\x20\xf1\xf2\xf0\xe5\xeb\xe0\xec\xe8\x20\xed\xe0\x20" >> $working_dir/deb_source/34.11.2012_test_message_2
    echo -en "\xf5\xf0\xe0\xe1\xf0\xfb\xff\x20\xef\xeb\xfa\xea\xfb\x20\xc8\xe3\xee" >> $working_dir/deb_source/34.11.2012_test_message_2
    echo -en "\xf0\xe5\xe2\xfb" >> $working_dir/deb_source/34.11.2012_test_message_2
}

create_DEBIAN_dir
create_gostsum_test_files
cd $working_dir
dpkg-deb -b deb_source/

gostsum -t

echo
ls $working_dir/deb_source.deb
echo

echo
echo GOST R 34.11.94
gostsum_from_deb --gost-94 -p $working_dir/deb_source.deb

echo
echo GOST 34.11.2012 256-bit
gostsum_from_deb --gost-2012 -p $working_dir/deb_source.deb

echo
echo GOST 34.11.2012 512-bit
gostsum_from_deb --gost-2012-512 -p $working_dir/deb_source.deb
